searchNodes=[{"doc":"Basic structures both useful for nostr relays and clients Takes care of: Cryptography SHA256 Schnorr Signatures Events Parsing Serialization Signing Validation Filters Parsing Serialization","ref":"NostrBasics.html","title":"NostrBasics","type":"module"},{"doc":"A message from a client to a relay Specification here: https://github.com/nostr-protocol/nips/blob/master/01.md#from-client-to-relay-sending-events-and-creating-subscriptions","ref":"NostrBasics.ClientMessage.html","title":"NostrBasics.ClientMessage","type":"module"},{"doc":"Converts a client message in string format to the actual related Elixir structure Examples iex&gt; ~s([&quot;EVENT&quot;,{&quot;content&quot;:&quot;gm nostr&quot;,&quot;created_at&quot;:1675881420,&quot;id&quot;:&quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot;,&quot;kind&quot;:1,&quot;pubkey&quot;:&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,&quot;sig&quot;:&quot;4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d&quot;,&quot;tags&quot;:[]}]) ...&gt; |&gt; NostrBasics.ClientMessage . parse ( ) { :event , % NostrBasics.Event { id : &quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-08 18:37:00Z] , kind : 1 , tags : [ ] , content : &quot;gm nostr&quot; , sig : &lt;&lt; 0x4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d :: 512 &gt;&gt; } } iex&gt; ~s([&quot;REQ&quot;,&quot;7c4924a0d6d3a88917744ea7616618f9&quot;,{&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}]) ...&gt; |&gt; NostrBasics.ClientMessage . parse ( ) { :req , [ % NostrBasics.Filter { subscription_id : &quot;7c4924a0d6d3a88917744ea7616618f9&quot; , since : nil , until : nil , limit : 10 , ids : [ ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , kinds : [ 1 ] , e : [ ] , p : [ ] } ] } iex&gt; ~s([&quot;CLOSE&quot;,&quot;7c4924a0d6d3a88917744ea7616618f9&quot;]) ...&gt; |&gt; NostrBasics.ClientMessage . parse ( ) { :close , % NostrBasics.CloseRequest { subscription_id : &quot;7c4924a0d6d3a88917744ea7616618f9&quot; } } iex&gt; ~s([&quot;WHAT&quot;, &quot;something new&quot;]) ...&gt; |&gt; NostrBasics.ClientMessage . parse ( ) { :unknown , &quot;Unknown nostr message type&quot; }","ref":"NostrBasics.ClientMessage.html#parse/1","title":"NostrBasics.ClientMessage.parse/1","type":"function"},{"doc":"Converts Jason encoded structures into NostrBasics elixir structures","ref":"NostrBasics.ClientMessage.Decoder.html","title":"NostrBasics.ClientMessage.Decoder","type":"module"},{"doc":"Converts Jason encoded structures into NostrBasics elixir structures Examples iex&gt; [ ...&gt; &quot;EVENT&quot; , ...&gt; %{ ...&gt; &quot;content&quot; =&gt; &quot;gm nostr&quot; , ...&gt; &quot;created_at&quot; =&gt; 1675881420 , ...&gt; &quot;id&quot; =&gt; &quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot; , ...&gt; &quot;kind&quot; =&gt; 1 , ...&gt; &quot;pubkey&quot; =&gt; &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; , ...&gt; &quot;sig&quot; =&gt; &quot;4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d&quot; , ...&gt; &quot;tags&quot; =&gt; [ ] ...&gt; } ...&gt; ] ...&gt; |&gt; NostrBasics.ClientMessage.Decoder . decode ( ) { :event , % NostrBasics.Event { id : &quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-08 18:37:00Z] , kind : 1 , tags : [ ] , content : &quot;gm nostr&quot; , sig : &lt;&lt; 0x4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d :: 512 &gt;&gt; } } iex&gt; [ ...&gt; &quot;REQ&quot; , ...&gt; &quot;7c4924a0d6d3a88917744ea7616618f9&quot; , ...&gt; %{ ...&gt; &quot;authors&quot; =&gt; [ &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; ] , ...&gt; &quot;kinds&quot; =&gt; [ 1 ] , ...&gt; &quot;limit&quot; =&gt; 10 ...&gt; } ...&gt; ] ...&gt; |&gt; NostrBasics.ClientMessage.Decoder . decode ( ) { :req , [ % NostrBasics.Filter { subscription_id : &quot;7c4924a0d6d3a88917744ea7616618f9&quot; , since : nil , until : nil , limit : 10 , ids : [ ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , kinds : [ 1 ] , e : [ ] , p : [ ] } ] } iex&gt; [ &quot;CLOSE&quot; , &quot;7c4924a0d6d3a88917744ea7616618f9&quot; ] ...&gt; |&gt; NostrBasics.ClientMessage.Decoder . decode ( ) { :close , % NostrBasics.CloseRequest { subscription_id : &quot;7c4924a0d6d3a88917744ea7616618f9&quot; } } iex&gt; ~s([&quot;WHAT&quot;, &quot;something new&quot;]) ...&gt; |&gt; NostrBasics.ClientMessage.Decoder . decode ( ) { :unknown , &quot;Unknown nostr message type&quot; }","ref":"NostrBasics.ClientMessage.Decoder.html#decode/1","title":"NostrBasics.ClientMessage.Decoder.decode/1","type":"function"},{"doc":"When a subscription's got to be closed... meant to be sent to a relay from a client.","ref":"NostrBasics.CloseRequest.html","title":"NostrBasics.CloseRequest","type":"module"},{"doc":"","ref":"NostrBasics.CloseRequest.html#t:t/0","title":"NostrBasics.CloseRequest.t/0","type":"type"},{"doc":"Crypto algorithms needed to communicate on the nostr network","ref":"NostrBasics.Crypto.html","title":"NostrBasics.Crypto","type":"module"},{"doc":"Computes SHA256 on a binary and returns it as a binary Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; NostrBasics.Crypto . sha256 ( ) &lt;&lt; 0xab6a8f1d9e2b0333dff8e370ed6fdfe20b2e8008e045efb3fb3298c22f7569da :: 256 &gt;&gt;","ref":"NostrBasics.Crypto.html#sha256/1","title":"NostrBasics.Crypto.sha256/1","type":"function"},{"doc":"Algorithm that encrypts and decrypts direct messages","ref":"NostrBasics.Crypto.AES256CBC.html","title":"NostrBasics.Crypto.AES256CBC","type":"module"},{"doc":"Decrypts a direct message Examples iex&gt; remote_public_key = &lt;&lt; 0xEFC83F01C8FB309DF2C8866B8C7924CC8B6F0580AFDDE1D6E16E2B6107C2862C :: 256 &gt;&gt; ...&gt; local_private_key = &lt;&lt; 0x4E22DA43418DD934373CBB38A5AB13059191A2B3A51C5E0B67EB1334656943B8 :: 256 &gt;&gt; ...&gt; &quot;sWLtVbabr8fzIugnOXo4og==?iv=nxF/xVqbC4JdMRUEC0Jfyg==&quot; ...&gt; |&gt; NostrBasics.Crypto.AES256CBC . decrypt ( local_private_key , remote_public_key ) { :ok , &quot;test&quot; }","ref":"NostrBasics.Crypto.AES256CBC.html#decrypt/3","title":"NostrBasics.Crypto.AES256CBC.decrypt/3","type":"function"},{"doc":"Encrypts a direct message The example below can't test for the result, as it changes on every execution... Examples iex&gt; remote_public_key = &lt;&lt; 0xEFC83F01C8FB309DF2C8866B8C7924CC8B6F0580AFDDE1D6E16E2B6107C2862C :: 256 &gt;&gt; ...&gt; local_private_key = &lt;&lt; 0x4E22DA43418DD934373CBB38A5AB13059191A2B3A51C5E0B67EB1334656943B8 :: 256 &gt;&gt; ...&gt; &quot;this message will end up being encrypted&quot; ...&gt; |&gt; NostrBasics.Crypto.AES256CBC . encrypt ( local_private_key , remote_public_key )","ref":"NostrBasics.Crypto.AES256CBC.html#encrypt/3","title":"NostrBasics.Crypto.AES256CBC.encrypt/3","type":"function"},{"doc":"Represents the basic structure of anything that's being sent to/from relays","ref":"NostrBasics.Event.html","title":"NostrBasics.Event","type":"module"},{"doc":"Adds an ID to an event that doesn't have one Examples iex&gt; % NostrBasics.Event { ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event . add_id % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; }","ref":"NostrBasics.Event.html#add_id/1","title":"NostrBasics.Event.add_id/1","type":"function"},{"doc":"Simplifies the creation of an event, adding the created_at and tags fields and requiring the bare minimum to do so Examples iex&gt; pubkey = &lt;&lt; 0xEFC83F01C8FB309DF2C8866B8C7924CC8B6F0580AFDDE1D6E16E2B6107C2862C :: 256 &gt;&gt; ...&gt; NostrBasics.Event . create ( 1 , &quot;this is the content&quot; , pubkey ) % NostrBasics.Event { pubkey : &lt;&lt; 0xefc83f01c8fb309df2c8866b8c7924cc8b6f0580afdde1d6e16e2b6107c2862c :: 256 &gt;&gt; , kind : 1 , content : &quot;this is the content&quot; , tags : [ ] }","ref":"NostrBasics.Event.html#create/3","title":"NostrBasics.Event.create/3","type":"function"},{"doc":"Creates an ID for an event that doesn't have one Examples iex&gt; % NostrBasics.Event { ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event . create_id &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot;","ref":"NostrBasics.Event.html#create_id/1","title":"NostrBasics.Event.create_id/1","type":"function"},{"doc":"Converts a NIP-01 JSON string decoded as a map by Jason into an %Event{} Examples iex&gt; %{ ...&gt; &quot;content&quot; =&gt; &quot;this is the content&quot; , ...&gt; &quot;created_at&quot; =&gt; 1675794272 , ...&gt; &quot;id&quot; =&gt; &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; &quot;kind&quot; =&gt; 1 , ...&gt; &quot;pubkey&quot; =&gt; &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; , ...&gt; &quot;tags&quot; =&gt; [ ] ...&gt; } ...&gt; |&gt; NostrBasics.Event . decode ( ) % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; }","ref":"NostrBasics.Event.html#decode/1","title":"NostrBasics.Event.decode/1","type":"function"},{"doc":"A structure an event has to be converted to prior to being SHA256'd, mainly for ID creation Examples iex&gt; % NostrBasics.Event { ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event . json_for_id ~s([0,&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,1675794272,1,[],&quot;this is the content&quot;])","ref":"NostrBasics.Event.html#json_for_id/1","title":"NostrBasics.Event.json_for_id/1","type":"function"},{"doc":"Converts a NIP-01 JSON string into a %Event{} Examples iex&gt; ~s({&quot;id&quot;:&quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot;,&quot;pubkey&quot;:&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,&quot;created_at&quot;:1675794272,&quot;kind&quot;:1,&quot;tags&quot;:[],&quot;content&quot;:&quot;this is the content&quot;}) ...&gt; |&gt; NostrBasics.Event . parse ( ) { :ok , % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; } }","ref":"NostrBasics.Event.html#parse/1","title":"NostrBasics.Event.parse/1","type":"function"},{"doc":"","ref":"NostrBasics.Event.html#t:t/0","title":"NostrBasics.Event.t/0","type":"type"},{"doc":"Event id conversion functions","ref":"NostrBasics.Event.Id.html","title":"NostrBasics.Event.Id","type":"module"},{"doc":"Converts a bech32 event id into its binary format Examples iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . from_bech32 { :ok , &quot;note&quot; , &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt; }","ref":"NostrBasics.Event.Id.html#from_bech32/1","title":"NostrBasics.Event.Id.from_bech32/1","type":"function"},{"doc":"Converts a bech32 event id into its binary format Examples iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . from_bech32! &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt;","ref":"NostrBasics.Event.Id.html#from_bech32!/1","title":"NostrBasics.Event.Id.from_bech32!/1","type":"function"},{"doc":"Converts an event binary id into a bech32 format Examples iex&gt; &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt; ...&gt; |&gt; NostrBasics.Event.Id . to_bech32 ( &quot;note&quot; ) &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; iex&gt; &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_bech32 ( &quot;note&quot; ) &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot;","ref":"NostrBasics.Event.Id.html#to_bech32/2","title":"NostrBasics.Event.Id.to_bech32/2","type":"function"},{"doc":"Does its best to convert any event id format to binary, issues an error if it can't Examples iex&gt; &quot;05a481f758dd370d6ce7b01bd0a65336ce0a3ff8e0f2c5859baa7414c0f2a40c&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_binary ( ) { :ok , &lt;&lt; 0x05a481f758dd370d6ce7b01bd0a65336ce0a3ff8e0f2c5859baa7414c0f2a40c :: 256 &gt;&gt; } iex&gt; &quot;note1qkjgra6cm5ms6m88kqdapfjnxm8q50lcurevtpvm4f6pfs8j5sxq90f098&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_binary ( ) { :ok , &lt;&lt; 0x05a481f758dd370d6ce7b01bd0a65336ce0a3ff8e0f2c5859baa7414c0f2a40c :: 256 &gt;&gt; } iex&gt; [ &lt;&lt; 0x73b0011409b488352545775d6b24b4de47ff8ff29998d7d61cdee7f9a9a208ee :: 256 &gt;&gt; ] ...&gt; |&gt; NostrBasics.Event.Id . to_binary ( ) { :ok , [ &lt;&lt; 0x73b0011409b488352545775d6b24b4de47ff8ff29998d7d61cdee7f9a9a208ee :: 256 &gt;&gt; ] }","ref":"NostrBasics.Event.Id.html#to_binary/1","title":"NostrBasics.Event.Id.to_binary/1","type":"function"},{"doc":"Converts any type of event id into a hex format Examples iex&gt; &lt;&lt; 0x2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2 :: 256 &gt;&gt; ...&gt; |&gt; NostrBasics.Event.Id . to_hex ( ) { :ok , nil , &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; } iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_hex { :ok , &quot;note&quot; , &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; }","ref":"NostrBasics.Event.Id.html#to_hex/1","title":"NostrBasics.Event.Id.to_hex/1","type":"function"},{"doc":"Converts a bech32 event id into a hex string format Examples iex&gt; &quot;note19e93faw4ffqepsqsrwrnstd3ee00nmzakwwuyfjm43dankgummfqms4p6q&quot; ...&gt; |&gt; NostrBasics.Event.Id . to_hex! &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot;","ref":"NostrBasics.Event.Id.html#to_hex!/1","title":"NostrBasics.Event.Id.to_hex!/1","type":"function"},{"doc":"Turns raw events from JSON websocket messages into elixir structs","ref":"NostrBasics.Event.Parser.html","title":"NostrBasics.Event.Parser","type":"module"},{"doc":"Converts a NIP-01 JSON string decoded as a map by Jason into an %Event{} Examples iex&gt; %{ ...&gt; &quot;content&quot; =&gt; &quot;this is the content&quot; , ...&gt; &quot;created_at&quot; =&gt; 1675794272 , ...&gt; &quot;id&quot; =&gt; &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; &quot;kind&quot; =&gt; 1 , ...&gt; &quot;pubkey&quot; =&gt; &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; , ...&gt; &quot;tags&quot; =&gt; [ ] ...&gt; } ...&gt; |&gt; NostrBasics.Event.Parser . decode ( ) % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; }","ref":"NostrBasics.Event.Parser.html#decode/1","title":"NostrBasics.Event.Parser.decode/1","type":"function"},{"doc":"Converts a NIP-01 JSON string into a %Event{} Examples iex&gt; ~s({&quot;id&quot;:&quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot;,&quot;pubkey&quot;:&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,&quot;created_at&quot;:1675794272,&quot;kind&quot;:1,&quot;tags&quot;:[],&quot;content&quot;:&quot;this is the content&quot;}) ...&gt; |&gt; NostrBasics.Event.Parser . parse ( ) { :ok , % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; } }","ref":"NostrBasics.Event.Parser.html#parse/1","title":"NostrBasics.Event.Parser.parse/1","type":"function"},{"doc":"Signs events, making sure they're going to be accepted on the nostr network as the user's own","ref":"NostrBasics.Event.Signer.html","title":"NostrBasics.Event.Signer","type":"module"},{"doc":"Applies the schnorr signatures to an event and adds signature to it if successful Examples iex&gt; private_key = &lt;&lt; 0x4e22da43418dd934373cbb38a5ab13059191a2b3a51c5e0b67eb1334656943b8 :: 256 &gt;&gt; ...&gt; % NostrBasics.Event { ...&gt; id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; kind : 1 , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Signer . sign_event ( private_key ) { :ok , % NostrBasics.Event { id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-07 18:24:32.596503Z] , kind : 1 , tags : [ ] , content : &quot;this is the content&quot; , sig : &lt;&lt; 0x985a5ffea93ccebaab4875c973186fac0e066a26222ddf932b8b5a98782a181baa1496394b13134e74f86a8b816bfccff152c7e66ef02e72bb9ae7db8d843680 :: 512 &gt;&gt; } }","ref":"NostrBasics.Event.Signer.html#sign_event/2","title":"NostrBasics.Event.Signer.sign_event/2","type":"function"},{"doc":"Makes sure a signature is valid","ref":"NostrBasics.Event.Validator.html","title":"NostrBasics.Event.Validator","type":"module"},{"doc":"Applies Schnorr signatures with the public key and the signature, making sure the event is properly signed Examples iex&gt; % NostrBasics.Event { ...&gt; id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; , ...&gt; sig : &lt;&lt; 0x985a5ffea93ccebaab4875c973186fac0e066a26222ddf932b8b5a98782a181baa1496394b13134e74f86a8b816bfccff152c7e66ef02e72bb9ae7db8d843680 :: 512 &gt;&gt; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Validator . validate_event ( ) :ok","ref":"NostrBasics.Event.Validator.html#validate_event/1","title":"NostrBasics.Event.Validator.validate_event/1","type":"function"},{"doc":"Recreates the event's ID and makes sur it's the same as the one already in the structure Examples iex&gt; % NostrBasics.Event { ...&gt; id : &quot;0f017fc299f6351efe9d5bfbfb36c0c7a1399627f9bec02c49b00d0ec98a5f34&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Validator . validate_id ( ) :ok iex&gt; % NostrBasics.Event { ...&gt; id : &quot;0000f&quot; , ...&gt; pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , ...&gt; created_at : ~U[2023-02-07 18:24:32.596503Z] , ...&gt; kind : 1 , ...&gt; tags : [ ] , ...&gt; content : &quot;this is the content&quot; ...&gt; } ...&gt; |&gt; NostrBasics.Event.Validator . validate_id ( ) { :error , &quot;generated ID and the one in the event don&#39;t match&quot; }","ref":"NostrBasics.Event.Validator.html#validate_id/1","title":"NostrBasics.Event.Validator.validate_id/1","type":"function"},{"doc":"","ref":"NostrBasics.Event.Validator.html#validate_signature/1","title":"NostrBasics.Event.Validator.validate_signature/1","type":"function"},{"doc":"Details of a client subscription request to a relay","ref":"NostrBasics.Filter.html","title":"NostrBasics.Filter","type":"module"},{"doc":"Converts a JSON decoded encoded filter into a %Filter{} Examples iex&gt; %{ ...&gt; &quot;authors&quot; =&gt; [ &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; ] , ...&gt; &quot;kinds&quot; =&gt; [ 1 ] , ...&gt; &quot;limit&quot; =&gt; 10 ...&gt; } ...&gt; |&gt; NostrBasics.Filter . decode ( &quot;a_subscription_id&quot; ) % NostrBasics.Filter { subscription_id : &quot;a_subscription_id&quot; , kinds : [ 1 ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , limit : 10 }","ref":"NostrBasics.Filter.html#decode/2","title":"NostrBasics.Filter.decode/2","type":"function"},{"doc":"Converts a NIP-01 JSON REQ string into a structured Filter Examples iex&gt; ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) ...&gt; |&gt; NostrBasics.Filter . from_req ( &quot;a_subscription_id&quot; ) { :ok , % NostrBasics.Filter { subscription_id : &quot;a_subscription_id&quot; , kinds : [ 1 ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , limit : 10 } }","ref":"NostrBasics.Filter.html#from_req/2","title":"NostrBasics.Filter.from_req/2","type":"function"},{"doc":"Converts a structured Filter into a NIP-01 JSON REQ string Examples iex&gt; % NostrBasics.Filter { ...&gt; subscription_id : &quot;a_subscription_id&quot; , ...&gt; kinds : [ 1 ] , ...&gt; authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , ...&gt; limit : 10 ...&gt; } ...&gt; |&gt; NostrBasics.Filter . to_query { :ok , ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) }","ref":"NostrBasics.Filter.html#to_query/1","title":"NostrBasics.Filter.to_query/1","type":"function"},{"doc":"","ref":"NostrBasics.Filter.html#t:t/0","title":"NostrBasics.Filter.t/0","type":"type"},{"doc":"Converts a string request to a structured subscription filter and back","ref":"NostrBasics.Filter.Parser.html","title":"NostrBasics.Filter.Parser","type":"module"},{"doc":"Converts a JSON decoded encoded filter into a %Filter{} Examples iex&gt; %{ ...&gt; &quot;authors&quot; =&gt; [ &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; ] , ...&gt; &quot;kinds&quot; =&gt; [ 1 ] , ...&gt; &quot;limit&quot; =&gt; 10 ...&gt; } ...&gt; |&gt; NostrBasics.Filter.Parser . decode ( &quot;a_subscription_id&quot; ) % NostrBasics.Filter { subscription_id : &quot;a_subscription_id&quot; , kinds : [ 1 ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , limit : 10 }","ref":"NostrBasics.Filter.Parser.html#decode/2","title":"NostrBasics.Filter.Parser.decode/2","type":"function"},{"doc":"Examples iex&gt; ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) ...&gt; |&gt; NostrBasics.Filter.Parser . from_req ( &quot;a_subscription_id&quot; ) { :ok , % NostrBasics.Filter { subscription_id : &quot;a_subscription_id&quot; , kinds : [ 1 ] , authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , limit : 10 } }","ref":"NostrBasics.Filter.Parser.html#from_req/2","title":"NostrBasics.Filter.Parser.from_req/2","type":"function"},{"doc":"Transaforms a %Filter{} into a NIP-01 JSON string","ref":"NostrBasics.Filter.Serializer.html","title":"NostrBasics.Filter.Serializer","type":"module"},{"doc":"Converts a structured Filter into a NIP-01 JSON REQ string Examples iex&gt; % NostrBasics.Filter { ...&gt; subscription_id : &quot;a_subscription_id&quot; , ...&gt; kinds : [ 1 ] , ...&gt; authors : [ &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; ] , ...&gt; limit : 10 ...&gt; } ...&gt; |&gt; NostrBasics.Filter.Serializer . to_req { :ok , ~s({&quot;authors&quot;:[&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;],&quot;kinds&quot;:[1],&quot;limit&quot;:10}) }","ref":"NostrBasics.Filter.Serializer.html#to_req/1","title":"NostrBasics.Filter.Serializer.to_req/1","type":"function"},{"doc":"A way to represent binaries in a human readable format that fits what's found on the web related to keys and addresses Example: &lt;&lt; 0x181DCB172F5B56DB39B6C8544068FEE69928556230B41E115BDB22BF82A06FF3 :: 256 &gt;&gt; instead of &lt;&lt; 24 , 29 , 203 , 23 , 47 , 91 , 86 , 219 , 57 , 182 , 200 , 84 , 64 , 104 , 254 , 230 , 153 , 40 , 85 , 98 , 48 , 180 , 30 , 17 , 91 , 219 , 34 , 191 , 130 , 160 , 111 , 243 &gt;&gt;","ref":"NostrBasics.HexBinary.html","title":"NostrBasics.HexBinary","type":"module"},{"doc":"Converts a binary string into a %HexBinary{} that the inspector will print in a compact way Examples iex&gt; &lt;&lt; 24 , 29 , 203 , 23 , 47 , 91 , 86 , 219 , 57 , 182 , 200 , 84 , 64 , 104 , 254 , 230 , 153 , 40 , 85 , 98 , 48 , 180 , 30 , 17 , 91 , 219 , 34 , 191 , 130 , 160 , 111 , 243 &gt;&gt; ...&gt; |&gt; NostrBasics.HexBinary . from_binary ( ) % HexBinary { data : &lt;&lt; 0x181DCB172F5B56DB39B6C8544068FEE69928556230B41E115BDB22BF82A06FF3 :: 256 &gt;&gt; }","ref":"NostrBasics.HexBinary.html#from_binary/1","title":"NostrBasics.HexBinary.from_binary/1","type":"function"},{"doc":"Private keys management functions","ref":"NostrBasics.Keys.PrivateKey.html","title":"NostrBasics.Keys.PrivateKey","type":"module"},{"doc":"Creates a new private key Examples iex&gt; NostrBasics.Keys.PrivateKey . create ( )","ref":"NostrBasics.Keys.PrivateKey.html#create/0","title":"NostrBasics.Keys.PrivateKey.create/0","type":"function"},{"doc":"Extracts a binary private key from the nsec format Examples iex&gt; nsec = &quot;nsec1d4ed5x49d7p24xn63flj4985dc4gpfngdhtqcxpth0ywhm6czxcs5l2exj&quot; ...&gt; NostrBasics.Keys.PrivateKey . from_nsec ( nsec ) { :ok , &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt; }","ref":"NostrBasics.Keys.PrivateKey.html#from_nsec/1","title":"NostrBasics.Keys.PrivateKey.from_nsec/1","type":"function"},{"doc":"Extracts a binary private key from the nsec format Examples iex&gt; nsec = &quot;nsec1d4ed5x49d7p24xn63flj4985dc4gpfngdhtqcxpth0ywhm6czxcs5l2exj&quot; ...&gt; NostrBasics.Keys.PrivateKey . from_nsec! ( nsec ) &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt;","ref":"NostrBasics.Keys.PrivateKey.html#from_nsec!/1","title":"NostrBasics.Keys.PrivateKey.from_nsec!/1","type":"function"},{"doc":"Does its best to convert any private key format to binary, issues an error if it can't Examples iex&gt; &quot;nsec1fc3d5s6p3hvngdeuhvu2t2cnqkgerg4n55w9uzm8avfngetfgwuqc25heg&quot; ...&gt; |&gt; NostrBasics.Keys.PrivateKey . to_binary ( ) { :ok , &lt;&lt; 0x4e22da43418dd934373cbb38a5ab13059191a2b3a51c5e0b67eb1334656943b8 :: 256 &gt;&gt; }","ref":"NostrBasics.Keys.PrivateKey.html#to_binary/1","title":"NostrBasics.Keys.PrivateKey.to_binary/1","type":"function"},{"doc":"Does its best to convert any private key format to binary, raises an error if it can't Examples iex&gt; &quot;nsec1fc3d5s6p3hvngdeuhvu2t2cnqkgerg4n55w9uzm8avfngetfgwuqc25heg&quot; ...&gt; |&gt; NostrBasics.Keys.PrivateKey . to_binary! ( ) &lt;&lt; 0x4e22da43418dd934373cbb38a5ab13059191a2b3a51c5e0b67eb1334656943b8 :: 256 &gt;&gt;","ref":"NostrBasics.Keys.PrivateKey.html#to_binary!/1","title":"NostrBasics.Keys.PrivateKey.to_binary!/1","type":"function"},{"doc":"Encodes a private key into the nsec format Examples iex&gt; private_key = &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt; ...&gt; NostrBasics.Keys.PrivateKey . to_nsec ( private_key ) &quot;nsec1d4ed5x49d7p24xn63flj4985dc4gpfngdhtqcxpth0ywhm6czxcs5l2exj&quot;","ref":"NostrBasics.Keys.PrivateKey.html#to_nsec/1","title":"NostrBasics.Keys.PrivateKey.to_nsec/1","type":"function"},{"doc":"","ref":"NostrBasics.Keys.PrivateKey.html#t:id/0","title":"NostrBasics.Keys.PrivateKey.id/0","type":"type"},{"doc":"Public keys management functions","ref":"NostrBasics.Keys.PublicKey.html","title":"NostrBasics.Keys.PublicKey","type":"module"},{"doc":"Converts a public key in the npub format into a binary public key that can be used with this lib Examples iex&gt; npub = &quot;npub1d4ed5x49d7p24xn63flj4985dc4gpfngdhtqcxpth0ywhm6czxcscfpcq8&quot; ...&gt; NostrBasics.Keys.PublicKey . from_npub ( npub ) { :ok , &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt; }","ref":"NostrBasics.Keys.PublicKey.html#from_npub/1","title":"NostrBasics.Keys.PublicKey.from_npub/1","type":"function"},{"doc":"Converts a public key in the npub format into a binary public key that can be used with this lib Examples iex&gt; npub = &quot;npub1d4ed5x49d7p24xn63flj4985dc4gpfngdhtqcxpth0ywhm6czxcscfpcq8&quot; ...&gt; NostrBasics.Keys.PublicKey . from_npub! ( npub ) &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt;","ref":"NostrBasics.Keys.PublicKey.html#from_npub!/1","title":"NostrBasics.Keys.PublicKey.from_npub!/1","type":"function"},{"doc":"Issues the public key corresponding to a given private key Examples iex&gt; private_key = &lt;&lt; 0xb6907368a945db7769b5eaecd73c3c175b77c64e1df3e9900acd66aeea7b53ab :: 256 &gt;&gt; ...&gt; NostrBasics.Keys.PublicKey . from_private_key ( private_key ) { :ok , &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt; }","ref":"NostrBasics.Keys.PublicKey.html#from_private_key/1","title":"NostrBasics.Keys.PublicKey.from_private_key/1","type":"function"},{"doc":"Issues the public key corresponding to a given private key Examples iex&gt; private_key = &lt;&lt; 0xb6907368a945db7769b5eaecd73c3c175b77c64e1df3e9900acd66aeea7b53ab :: 256 &gt;&gt; ...&gt; NostrBasics.Keys.PublicKey . from_private_key! ( private_key ) &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt;","ref":"NostrBasics.Keys.PublicKey.html#from_private_key!/1","title":"NostrBasics.Keys.PublicKey.from_private_key!/1","type":"function"},{"doc":"Does its best to convert any public key format to binary, issues an error if it can't Examples iex&gt; &quot;npub1mxrssnzg8y9zjr6a9g6xqwhxfa23xlvmftluakxqatsrp6ez9gjssu0htc&quot; ...&gt; |&gt; NostrBasics.Keys.PublicKey . to_binary ( ) { :ok , &lt;&lt; 0xd987084c48390a290f5d2a34603ae64f55137d9b4affced8c0eae030eb222a25 :: 256 &gt;&gt; }","ref":"NostrBasics.Keys.PublicKey.html#to_binary/1","title":"NostrBasics.Keys.PublicKey.to_binary/1","type":"function"},{"doc":"Converts a public key into a string containing hex characters Examples iex&gt; public_key = &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt; ...&gt; NostrBasics.Keys.PublicKey . to_hex ( public_key ) &quot;6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1&quot;","ref":"NostrBasics.Keys.PublicKey.html#to_hex/1","title":"NostrBasics.Keys.PublicKey.to_hex/1","type":"function"},{"doc":"Encodes a public key into the npub format Examples iex&gt; public_key = &lt;&lt; 0x6d72da1aa56f82aa9a7a8a7f2a94f46e2a80a6686dd60c182bbbc8ebef5811b1 :: 256 &gt;&gt; ...&gt; NostrBasics.Keys.PublicKey . to_npub ( public_key ) &quot;npub1d4ed5x49d7p24xn63flj4985dc4gpfngdhtqcxpth0ywhm6czxcscfpcq8&quot;","ref":"NostrBasics.Keys.PublicKey.html#to_npub/1","title":"NostrBasics.Keys.PublicKey.to_npub/1","type":"function"},{"doc":"","ref":"NostrBasics.Keys.PublicKey.html#t:id/0","title":"NostrBasics.Keys.PublicKey.id/0","type":"type"},{"doc":"A message from a relay to a client Specifications here: https://github.com/nostr-protocol/nips/blob/master/01.md#from-relay-to-client-sending-events-and-notices https://github.com/nostr-protocol/nips/blob/master/15.md https://github.com/nostr-protocol/nips/blob/master/20.md","ref":"NostrBasics.RelayMessage.html","title":"NostrBasics.RelayMessage","type":"module"},{"doc":"Converts a client message in string format to the actual related Elixir structure Examples iex&gt; ~s([&quot;EVENT&quot;,&quot;b9dcd5af35446678eec7fa6748eb7357&quot;,{&quot;content&quot;:&quot;gm nostr&quot;,&quot;created_at&quot;:1675881420,&quot;id&quot;:&quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot;,&quot;kind&quot;:1,&quot;pubkey&quot;:&quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot;,&quot;sig&quot;:&quot;4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d&quot;,&quot;tags&quot;:[]}]) ...&gt; |&gt; NostrBasics.RelayMessage . parse ( ) { :event , &quot;b9dcd5af35446678eec7fa6748eb7357&quot; , % NostrBasics.Event { id : &quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-08 18:37:00Z] , kind : 1 , tags : [ ] , content : &quot;gm nostr&quot; , sig : &lt;&lt; 0x4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d :: 512 &gt;&gt; } } iex&gt; ~s([&quot;NOTICE&quot;,&quot;a notice from the relay&quot;]) ...&gt; |&gt; NostrBasics.RelayMessage . parse ( ) { :notice , &quot;a notice from the relay&quot; } iex&gt; ~s([&quot;EOSE&quot;,&quot;b9dcd5af35446678eec7fa6748eb7357&quot;]) ...&gt; |&gt; NostrBasics.RelayMessage . parse ( ) { :end_of_stored_events , &quot;b9dcd5af35446678eec7fa6748eb7357&quot; } iex&gt; ~s([&quot;OK&quot;,&quot;3dafe573cc12c0292519cf54391bcd29135c7d313729b3e3835b0c222d31748b&quot;,true,&quot;&quot;]) ...&gt; |&gt; NostrBasics.RelayMessage . parse ( ) { :ok , &quot;3dafe573cc12c0292519cf54391bcd29135c7d313729b3e3835b0c222d31748b&quot; , true , &quot;&quot; } iex&gt; ~s([&quot;EVENT&quot;) ...&gt; |&gt; NostrBasics.RelayMessage . parse ( ) { :json_error , &quot;error decoding JSON at position 8: &quot; }","ref":"NostrBasics.RelayMessage.html#parse/1","title":"NostrBasics.RelayMessage.parse/1","type":"function"},{"doc":"Converts Jason encoded structures into NostrBasics elixir structures","ref":"NostrBasics.RelayMessage.Decoder.html","title":"NostrBasics.RelayMessage.Decoder","type":"module"},{"doc":"Converts Jason encoded structures into NostrBasics elixir structures Examples iex&gt; [ ...&gt; &quot;EVENT&quot; , ...&gt; &quot;b9dcd5af35446678eec7fa6748eb7357&quot; , ...&gt; %{ ...&gt; &quot;content&quot; =&gt; &quot;gm nostr&quot; , ...&gt; &quot;created_at&quot; =&gt; 1675881420 , ...&gt; &quot;id&quot; =&gt; &quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot; , ...&gt; &quot;kind&quot; =&gt; 1 , ...&gt; &quot;pubkey&quot; =&gt; &quot;5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2&quot; , ...&gt; &quot;sig&quot; =&gt; &quot;4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d&quot; , ...&gt; &quot;tags&quot; =&gt; [ ] ...&gt; } ...&gt; ] ...&gt; |&gt; NostrBasics.RelayMessage.Decoder . decode ( ) { :event , &quot;b9dcd5af35446678eec7fa6748eb7357&quot; , % NostrBasics.Event { id : &quot;c899ed67ac6c736648f1809cf17d187ba2599a7fb2ab85359e19a78cd627a6b9&quot; , pubkey : &lt;&lt; 0x5ab9f2efb1fda6bc32696f6f3fd715e156346175b93b6382099d23627693c3f2 :: 256 &gt;&gt; , created_at : ~U[2023-02-08 18:37:00Z] , kind : 1 , tags : [ ] , content : &quot;gm nostr&quot; , sig : &lt;&lt; 0x4868c4307638289cd2c3c56aa53eb6ff89372a3ff3b8d744e347889f06bb01e78e0a9704301ea226581e08210984212e275d98fc1d7704406fc4149fb345b19d :: 512 &gt;&gt; } } iex&gt; [ &quot;NOTICE&quot; , &quot;this is a message from the relay&quot; ] ...&gt; |&gt; NostrBasics.RelayMessage.Decoder . decode ( ) { :notice , &quot;this is a message from the relay&quot; } iex&gt; [ &quot;EOSE&quot; , &quot;b9dcd5af35446678eec7fa6748eb7357&quot; ] ...&gt; |&gt; NostrBasics.RelayMessage.Decoder . decode ( ) { :end_of_stored_events , &quot;b9dcd5af35446678eec7fa6748eb7357&quot; } iex&gt; [ &quot;OK&quot; , &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; , true , &quot;successfully stored&quot; ] ...&gt; |&gt; NostrBasics.RelayMessage.Decoder . decode ( ) { :ok , &quot;2e4b14f5d54a4190c0101b87382db1ce5ef9ec5db39dc2265bac5bd9d91cded2&quot; , true , &quot;successfully stored&quot; }","ref":"NostrBasics.RelayMessage.Decoder.html#decode/1","title":"NostrBasics.RelayMessage.Decoder.decode/1","type":"function"},{"doc":"Basic structures both useful for nostr relays and clients Takes care of: Keys Private keys Public keys Client nostr messages Event Req Close Relay nostr messages Event Notice EOSE Cryptography SHA256 Schnorr Signatures Events Parsing Serialization Signing Validation Filters Parsing Serialization","ref":"readme.html","title":"NostrBasics","type":"extras"},{"doc":"The package can be installed by adding nostr_basics to your list of dependencies in mix.exs : def deps do [ { :nostr_basics , &quot;~&gt; 0.0.15&quot; } ] end","ref":"readme.html#installation","title":"NostrBasics - Installation","type":"extras"}]